const BbPromise = require('bluebird')
const ora = require('ora')

const getConfig = require('../utils/getConfig')
const fs = require('../utils/fs/index')

const getOrCreateRole = require('../utils/aws/getOrCreateRole')
const createOrUpdateLambda = require('../utils/aws/createOrUpdateLambda')
const getOrCreateRestApi = require('../utils/aws/getOrCreateRestApi')

const { pack } = fs

module.exports = async () => {
  const spinner = ora('Syncing').start()
  const config = await getConfig()
  const res = await BbPromise.all([getOrCreateRole(`${config.name}-lambda`, 'lambda.amazonaws.com', config.region), getOrCreateRole(`${config.name}-apig`, 'apigateway.amazonaws.com', config.region), pack()])
  const lambdaRoleArn = res[0]
  const apigRoleArn = res[1]
  const pkg = res[2]
  const lambdaArn = await createOrUpdateLambda({ ...config, lambdaRoleArn, pkg })
  const SID = await getOrCreateRestApi({ ...config, apigRoleArn, lambdaArn })
  spinner.succeed(`SID: ${SID} (${config.region})`)
}
